package com.bytesw.bytebot.service;

import com.bytesw.bytebot.bean.SchedulerTaskBean;
import com.bytesw.bytebot.model.SchedulerTask;
import com.bytesw.bytebot.repository.SchedulerTaskRepository;
import com.bytesw.xdf.exception.NotFoundException;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.*;

@Service
@Transactional
public class SchedulerTaskService extends XDFService<SchedulerTask, SchedulerTaskBean, BigInteger> {

//    @Autowired
//    private CalendarService calendarService;
//    @Autowired
//    private CalendarService CalendarService;
//    @Autowired
//    private CalendarRepository calendarRepository;

    protected SchedulerTaskService(SchedulerTaskRepository repository) {
        super(repository);
    }

    @Override
    protected SchedulerTask toModel(SchedulerTask model, SchedulerTaskBean bean) {
        if (model == null) {
            model = new SchedulerTask();
        }
        BeanUtils.copyProperties(bean, model);
        model.setInternals("Y".equals(bean.getInternals()));

//        Optional<Calendar> calendarOptional = calendarRepository.findById(bean.getCalendar());
//        if (!calendarOptional.isPresent()) {
//            throw new NotFoundException("Calendar not found " + bean.getCalendar());
//        }
//        model.setCalendar(calendarOptional.get());

        model.setCalendar("Mientras Se implementa Calendario en Backend");

        return model;
    }

    @Override
    protected SchedulerTaskBean toBean(SchedulerTask model) {
        SchedulerTaskBean bean = new SchedulerTaskBean();
        BeanUtils.copyProperties(model, bean);
        bean.setInternals(model.getInternals().booleanValue() ? "Y" : "N");
//        bean.setCalendar(model.getCalendar().getId());
        bean.setCalendar(model.getCalendar());
//        bean.setCalendarName(model.getCalendar().getName());
        bean.setCalendarName(model.getCalendar());
        return bean;
    }

    public Map<String, List> getInitialData() {
//        List<CalendarBean> calendarBeanList = CalendarService.getAll();
        List<String> calendarBeanList = new ArrayList<>();
        calendarBeanList.add("Hola Mundo");
        Map<String, List> initialData = new HashMap<>();
        initialData.put("calendarList", calendarBeanList);
        return initialData;
    }
}
